#define		F_CPU	2000000UL
#include	<avr/io.h>
#include	<util/delay.h>

void toggle(PORT_t *io) {			// zamiana stanu pinu 0 wskazanego portu na przeciwny
	io->OUTTGL = PIN0_bm;
}

int main(void) {
   
   // rne sposoby na ustawienie pinu 0 kadego portu jako wyjcie
   PORTA.DIR	=	PIN0_bm;				// bit mask
   PORTB.DIR	=	(1<<PORT0);				// po nazwie
   PORTC.DIR	=	0b00000001;				// warto binarna
   PORTD.DIR	=	0x01;					// warto szesnatkowa
   PORTE.DIR	=	1;						// warto dziesitna
   
   // pin E5 jako wejcie z podcigniciem do zasilania
   PORTE.DIRCLR		=	PIN5_bm;
   PORTE.PIN5CTRL	=	PORT_OPC_PULLUP_gc;
   
   while(1) {
	    _delay_ms(500);						// czekanie 500ms
		PORTA_OUT		|=	(1<<PIN0_bp);   // ustawienie bitu po staremu
		PORTB.OUTSET	=	PIN0_bm;		// ustawienie bitu po nowemu
		
		_delay_ms(500);						// czekanie 500ms
		PORTA_OUT		&= ~(1<<PIN0_bp);   // zerowanie bitu po staremu
		PORTB.OUTCLR	=	PIN0_bm;		// zerowanie bitu po nowemu
		
		toggle(&PORTC);
		
		if(!(PORTE.IN & PIN5_bm)) {			// jeeli przycisk wcinity
			toggle(&PORTD);
		} else {							// jeeli przycisk zwolniony
			toggle(&PORTE);
		}
   }
}